package at.hl.okb.wsclient.handler;

import java.io.IOException;
import java.io.InputStream;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.CertificateException;
import java.util.Iterator;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.UnsupportedCallbackException;

import com.sun.xml.wss.impl.callback.KeyStoreCallback;


public class TrustStoreCallbackHandler implements CallbackHandler {

    KeyStore keyStore = null;
    String password = "changeit";
    public TrustStoreCallbackHandler() {
            System.out.println("Truststore CBH.CTOR Called..........");
            InputStream is = null;
            try {
                keyStore = KeyStore.getInstance("JKS");
                //String keystoreURL = "C:\\Users\\HolperM\\.netbeans\\6.9\\config\\GF3\\domain1\\config\\cacerts.jks";
                //String keystoreURL = "C:\\Users\\HolperM\\.netbeans\\6.9\\config\\GF3\\domain1\\config\\keystoreHL.jks";
                //FIXME
                is = this.getClass().getClassLoader().getResourceAsStream("HLOKB_KeystoreLocalhost.jks");
                //is = new FileInputStream(keystoreURL);//keystoreURL);
                //keyStore.load(is, "changeit".toCharArray());
                keyStore.load(is, "mh2404".toCharArray());
            } catch (IOException ex) {
                Logger.getLogger(TrustStoreCallbackHandler.class.getName()).log(Level.SEVERE, null, ex);
                 throw new RuntimeException(ex);
            } catch (NoSuchAlgorithmException ex) {
                Logger.getLogger(TrustStoreCallbackHandler.class.getName()).log(Level.SEVERE, null, ex);
                 throw new RuntimeException(ex);
            } catch (CertificateException ex) {
                Logger.getLogger(TrustStoreCallbackHandler.class.getName()).log(Level.SEVERE, null, ex);
                 throw new RuntimeException(ex);
            } catch (KeyStoreException ex) {
                Logger.getLogger(TrustStoreCallbackHandler.class.getName()).log(Level.SEVERE, null, ex);
                 throw new RuntimeException(ex);
            } finally {
                try {
                	if (is!=null)
                		is.close();
                } catch (IOException ex) {
                    Logger.getLogger(TrustStoreCallbackHandler.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
    }
    public void handle(Callback[] callbacks) throws IOException, UnsupportedCallbackException {
        System.out.println("Truststore CBH.handle() Called..........");
         for (int i = 0; i < callbacks.length; i++) {
            if (callbacks[i] instanceof KeyStoreCallback) {
                KeyStoreCallback cb = (KeyStoreCallback) callbacks[i];
                print(cb.getRuntimeProperties());
                cb.setKeystore(keyStore);
            } else {
                throw new UnsupportedCallbackException(callbacks[i]);
            }
        }
    }
    private void print(Map context) {
         Iterator it = context.keySet().iterator();
         while (it.hasNext()) {
             System.out.println("Prop " + it.next());
         }
     }
}
